//  drifomga.t  - High Tech Drifter:  Omegatron
//
//  Copyright (c) 1988 by Michael J. Roberts and James B. Cser
//  All Rights Reserved.
//

WayneTalk: function;
endgame: function;

//
// guard2fence is the fuse which sends the guard to investigate the sparking
// on the fence
//
guard2fence: function
{
    if ( Me.location = guard.location )
    {
        "\n\tThe guard looks toward the south, seeming to have noticed some
	commotion. He starts to walk south, then turns toward you. \"Don't
	you try any preversions while I'm gone, or I'll blow your head off,\"
	he warns you sternly, then walks off to the south.\n";
	global.score := global.score + 2;
    }
    guard.moveInto( southbushes);
    if ( Me.location = guard.location )
    {
        "\n\tThe guard wanders up to the fence to investigate the electrical
	mishap. He sees you standing proudly next to your handiwork, and
	the pieces fall together in his mind. \"Hey, buddy, you're gonna
	have to answer to OMEGATRON Corporation for this damage. Better
	yet, I think I'll just blow your head off.\" Which he does.";
	die();
    }
}

omegaroad: room
    sdesc = "Road to Omegatron"
    ldesc = "You are now travelling on another expressway.
            The scenery is much the same, but with a few
	    more buildings to the sides.  To the west are the Western
	    Mountains of the Germanium Valley.  Perched imposingly
	    is a large white building of complex architecture, with 
	    several smaller buildings nestled in the foothills just
	    beneath it.  The road continues east and west."	          
    west = labfront
    east = junction
;

revolver: item
    noun = 'gun' 'revolver'
    sdesc = "revolver"
    location = guard
    isweapon = true
;

guard: Actor
    noun = ['guard''him']
    sdesc = "guard"
    ldesc = "The guard is a surly-looking individual. You suspect that he'd
             rather be at a donut shop than here, but he seems to be making
	     the best of it."
    actorDesc = "A guard is standing nearby, watching your every move, his
             hand edging toward his service revolver.\n"
    actorAction( v, d, p, i ) =
    {
        "The guard looks at you oddly. \"You're not thinking of some
	kinda preversion, are you? 'Cause if you are, I'll blow your
	head off.\"";
	exit;
    }
    verGrab( item ) =
    {
        if ( item = revolver )
        {
	    "The guard grabs his revolver before you can.  \"That wasn't
	    very smart,\" he says.  \"I'm going to have to ask you to
	    accompany me downtown.  On second thought, I'll just shoot
	    you now.\"  He opens fire.";
	    die();
	}
	"The guard pulls his revolver.  \"Freeze right there,\" he says.
	You wisely do so.  After a few moments, he relaxes and puts his
	revolver back in its holster.";
    }
    location = labfront
;

labfront: room
    sdesc = "Main Gate"        
    ldesc = 
    {
        "You are now before the main entrance of the OMEGRTRON complex.
	 A marble archway which reads \"OMEGATRON\" spans the road,
	 daring you to enter.  A guard gate is to the west, a clump of
	 bushes lies to the south, and the road continues east.";
    }	 
    east = omegaroad
    westAttempts = 0
    west = 
    {
        if ( guard.location = labfront )
	{
	    if ( labfront.westAttempts = 0 )
	        "The guard grabs you by the arm and stops you from going
		any further. \"Let's see some ID, buddy,\" he says, allowing
		you to see the revolver in his holster. \"You know what I
		think? I think you're some kinda prevert, and you and all
		the other preverts are organizing some kinda mutiny of
		preversion, that's what I think!\"";
	    else if ( labfront.westAttempts = 1 )
	        "The guard pulls his revolver and points it at you. \"Hey!
		You stay right where you are! Try going in there one
		more time, or try any other preversions, and I'll blow
		your head off!\"";
	    else
	    {
	        "\"Okay, that's it, buddy.\" It takes a few tries, but the
		guard eventually manages to get you in this sights of his
		revolver as he's pulling the trigger.";
		die();
		// die() never returns
	    }
	    labfront.westAttempts := labfront.westAttempts + 1;
	    return( nil );
	}
        return( eastyard );
    }
    south = southbushes
;

southbushes: room
    sdesc = "Bushes"
    ldesc = 
    {
        "This is a clump of bushes in front of the gate.  A tall electric 
	 fence stands to the west. ";
	if ( ashtray.location = fence )
	    "The base of the fence is violently spitting blue and
	    white electrical sparks at a point where something metallic
	    has fallen. ";
    }
    north = labfront
;    	            

fencesign: signitem
    noun = ['sign']
    sdesc = "sign"
    ldesc = "\"Caution - 20000 Volts\""
    location = southbushes
;
    
bushes: decoration
    noun = 'bush' 'bushes' 'clump'
    sdesc = "bushes"
    adesc = "a clump of bushes"
    ldesc = "The bushes look like nice shrubberies, but not too expensive. "
    location = southbushes
;

fence: fixeditem
    noun = 'fence'
    adjective = 'electric' 'electrified'
    sdesc = "electric fence"
    adesc = "an electric fence"
    location = southbushes
    ldesc =
    {
        "A small sign on the fence says \"Caution - 20000 Volts\". ";
	if ( ashtray.location = fence )
	    "A shower of sparks is emanating from a small metal object
	    which has lodged itself between the base of the fence and
	    a puddle of water. ";
    }
    verDoClimb( actor ) = {}
    doClimb( actor ) =
    {
        "You start to climb the fence, and then recall that it's
	electrified, then realize that that's the reason you're
	feeling 20000 volts rushing through your body.  (Quite
	unhealthy, 20000 volts are.) ";
	die();
    }
;

stairfoot: room
    sdesc = "Foot of Stairs"
    ldesc = "You are at the east end of a corridor, at the foot of some 
           stairs to the north.  The top of the staircase looks very dark and 
	   scary, and you probably don't want to try to go up.  The corridor
	   continues to the west, and the secretary's lair is to the east."
    north = stairmiddle
    up = stairmiddle
    west = corridor
//    south = lockerroom
    east = omegalobby
;

//lockerroom: room
//    sdesc = "Locker Room"
//    ldesc = "Locker Room"
//    north = stairfoot
//    east = spa
//;
    
//spa: room
//    sdesc = "Spa"
//    ldesc = "Spa"
//    east = lockerroom
//;              
            
stairmiddle: room
    sdesc = "Middle of Stairs"
    ldesc =
    {
        "We told you so.";
	die();
	abort;
    }  
    down = stairfoot
    up = stairtop
;

stairtop: room
    sdesc = "Top of Stairs"
    ldesc = "Top of Stairs"
    down = stairmiddle
    north = stairmiddle
;    
    
corridor: room
    sdesc = "Corridor"
    ldesc = "You are directly in front of a large mahogany door to the west.
            A small nameplate is attached to the wall.  The corridor leads
	    east."
    west =
    {
        if ( waynedoor.isopen )
            return( wayneroom );
        else
	{
	    "The door is closed.";
	    setit( waynedoor );
	    return( nil );
        }
    }		    	   
    east = stairfoot
;

waynedoor: doorway
    ldesc = "The door (<< waynedoor.isopen ? "open" : "closed" >>)
	is very large and of very high quality mahogany,
        and flaunts gold-plated handles. "
    sdesc = "mahogany door"
    location = corridor
    noun = 'door'
    adjective = 'mahogany'
;

nameplate: signitem, fixeditem
    noun = 'nameplate'
    adjective = 'small'
    sdesc = "nameplate"
    ldesc = "The nameplate reads \"Patrick J Wayne\", printed in
             a tasteful typestyle, with the word \"OFFICIAL\" haphazardly 
	     stamped over it in red ink. "
    location = corridor
;
	     
    
wayneroom: room
    sdesc =
    {
        if ( self.isseen )
	    "Wayne's Office";
	else
	    "Small Room";
    }
    ldesc =
    {
        if( not self.isseen )
        {
            "\n\tAs you step into the small room, the door slides shut
	    behind you, and you realize that you are inside an elevator
	    car.  You feel a slight lurch, but when the elevator
	    begins to move, you can barely tell that it is moving at all.
	    After a few moments the door slides open, and as you step
	    out into the room it clangs shut behind you.
	    Across the room, a man is standing behind a large desk. 
	    He seems to have become deranged. 
	    \n\t\"Good afternoon, Drifter. I've been expecting you.\"
	    The man laughs rather maniacally.\bWayne's Office";
	    
	    setdaemon( WayneTalk, nil );
	    global.score := global.score + 14;
	}
	"\n\tYou are standing at the west end of an extremely plush 
	office.  Wood panelling lines the walls, and there are
	large picture windows facing east.  A thick wall-to-wall
	shag carpet, complete with OMEGATRON logo, covers the floor.
	In front of the windows is a tidy mahogany desk, next to
	which is a giant lever.  The dreaded Patrick J Wayne 
	raves maniacally. There is a door to the west.";
    }	 
;                  

Wayne: Actor   
    noun = ['Wayne' 'man' 'him']
    adjective = 'dreaded' 'Patrick' 'J'
    istrapped = nil
    endcount = 0
    count = 0
    sdesc = "Patrick J Wayne"
    adesc = { self.sdesc; }
    thedesc = { self.sdesc; }
    heredesc =
    {
        if ( Wayne.istrapped )
	    "Patrick J Wayne is standing in front of his desk, running
	    back and forth trying to catch you. ";
	else
	    "Patrick J Wayne is standing behind his desk, cackling madly.";
    }
    ldesc = "He is a tall, white-haired, middle-aged man.  He is wearing
            an expensive gray suit.  He seems to have become deranged."
    actorAction( v, d, p, i ) =
    { 
        "\"Shut up! Just shut up! I'm talking now!\"";
        exit;
    }
    location = wayneroom
;  

waynedesk: fixeditem, surface
    noun = 'desk'
    adjective = 'mahogany'
    sdesc = "desk"
    ldesc =
    {
        "It's a huge antique mahogany desk. ";
	pass ldesc;
    }
    location = wayneroom
;
 
waynedisk: item
    noun = 'disk''recipe'
    adjective = 'floppy''dark''gray'
    sdesc = "dark gray floppy disk"
    ldesc = "A dark gray standard-sized floppy disk, affixed with the label
             \"Ma nad Pa's Secret Recipe\"."
    doTake( actor ) =
    {
        if( Wayne.count < 5 )
        {
	    "\n\t\"Oh no you don't!\"  Wayne pulls the lever next to
	    the desk, and you fall through a trap door.";
	    die();
	}
	else pass doTake;
    }
    location = waynedesk
;    	     
            
    
window: fixeditem
    noun = ['window''windows']
    adjective = 'large''picture'
    sdesc = "picture window"
    ldesc = "Large picture windows, presumably bulletproof."
    thrudesc = "The windows offer a breathtaking view of the Germanium
              Valley.  Distant mountains stand in the east, and on
	      the valley floor you can see the grasslands, the expressways,
	      and all the industrial parks put out of business by OMEGATRON.
	      It is the sort of vantage point that could easily incite one to
	      megalomania." 
    location = wayneroom
;

lever: fixeditem
    noun = 'lever'
    sdesc = "lever"
    ldesc = "A long brass lever, the sort that would operate a trap door."
    verDoPull( actor ) = {}
    doPull( actor ) =
    {
        if ( Wayne.istrapped )
	{
	    global.score := global.score + 2;
			  
	    "\n\tAs you pull the lever, Wayne falls through
	    a trap door in the floor. After recovering the secret
	    recipe, you eventually make it back to Pa's house and
	    report the good news.  In gratitude, Pa introduces you
	    to his (beautiful daughter/handsome son), and
	    offers you a high-paying consulting job.
	    Perhaps it's time to stop drifting for awhile.\b";
            
	    terminate();
	    quit();
	    abort;
	}
        else 
	{
	    "\n\tAs you stupidly pull the lever, you fall through the
	    trap door in the floor.  Needless to say, Patrick
	    J Wayne conquers the Germanium Valley.";
	    die();
	    abort;
	}
    }
    location = wayneroom
;

waynedoor2: doorway
    noun = 'door'
    isopen = nil
    adjective = 'large'
    sdesc = "large door"
    ldesc = "It's a very large door. "
    doOpen( actor ) =
    {
        "It won't budge. ";
    }
    location = wayneroom
;           

waynecomp: item 
    noun = 'computer'
    sdesc = "computer"   
    doTake( actor ) =
    { 
        "\"Touch that and die!\" Wayne warns.";
    }	      
    location = waynedesk	        
;    
    
endgame: function( param )
{
    if ( Wayne.endcount = 1 )
    {
        if ( gamedisk.location <> waynedesk and
	 waynedisk.location <> waynedesk )
        { 
            "\n\tWayne turns around, and notices that the disk is missing
	    from his desk.\"What are you trying to pull?  We'll
	    see about that!\"  The dreaded Patrick J Wayne proceeds
	    to pull the lever next to his desk, and you fall through a 
	    trap door in the floor.  Needless to say, he conquers the 
	    Germanium Valley.";
	    die();
	}
        else if( gamedisk.location = waynedesk and
	 waynedisk.location = waynedesk )
        {
	    "\n\tWayne turns around to see both disks on his desk. \"What
	    are you trying to pull?  We'll see about that!\"  The dreaded
	    Patrick J Wayne proceeds to pull the lever next to his desk,
	    and you fall through a trap door in the floor.  Needless to
	    say, he conquers the Germanium Valley.";
	    die();
        }
        else if ( gamedisk.location <> waynedesk and
         waynedisk.location = waynedesk )
        {
	    "\n\tWayne turns around and picks up the disk. \"You were just a
	    little too late, Drifter.\"  He puts the disk in the slot,
	    the drive whirrs for a few moments, and the computer beeps
	    twice.  \"Goodbye, Drifter.\", he says with an evil smile.
	    With that, the dreaded Patrick J Wayne pulls the handle 
	    on the lever next to the desk, and you fall through a trap door 
	    in the floor.  Needless to say, he conquers the Germanium 
	    Valley.";
	    die();
	}			          
        else if ( gamedisk.location = waynedesk and
         waynedisk.location <> waynedesk )
        {
	    "\n\tWayne turns around and picks the disk up off the desk,
	    not realizing that a switch has been made. \"You were a
	    little too late, Drifter.\"  He puts the disk in the 
	    slot, the drive whirrs for a few moments, but then the
	    computer begins to smoke and spark.  Wayne, furious, begins
	    to cry out \"I'm ruined! I'm ruined!\", and starts to chase
	    you around the desk.  You are now behind the desk, and he is
	    in front.";
	    Wayne.istrapped := true;
	    global.score := global.score + 3;
	}  
    }
    else if ( Wayne.endcount = 2 or Wayne.endcount = 4 )
    {
        "\n\tWayne is now behind the desk, and you are in front.";
	Wayne.istrapped := nil;
    }
    else if ( Wayne.endcount = 3 or Wayne.endcount = 5 )
    {
        "\n\tYou are back behind the desk, and Wayne is in front.";
	Wayne.istrapped := true;
    }  
    else if ( Wayne.endcount = 6 )
    {
        "\n\tWayne, having had enough, says \"Goodbye, Drifter!\", 
	pulls the lever next to the desk, and you fall through
	a trap door in the floor.  Needless to say, he conquers
	the Germanium Valley.";
	die();
    }
    Wayne.endcount := Wayne.endcount + 1;		   
}

//
//   WayneTalk begins the maniacal ravings of PJW.
//
//
WayneTalk: function( param )
{
    if ( Wayne.count = 1 )
    {
        "\n\t\"Yes, I know all about you, Drifter.  Do you think you could
        have caused all this commotion without my knowledge?  You're
	even more stupid that I had imagined.  It will take more than
	the likes of you to get in my way.\"";
    }
    else if ( Wayne.count = 2 )  	 
    {
        "\n\t\"Of course I stole Ma and Pa's recipe, in case you were
        wondering.\"  He picks up a floppy disk that is lying on his
	desk. \" They developed a new chip-making technique that
	will put OMEGATRON at the state of the art for decades.  I'll
	bet those doddering old fools don't even know it's gone! ";
    }
    else if ( Wayne.count = 3 )
    {
        "\n\t\"All I have to do is to stick this in this computer, send
        the information to the rest of the lab, and I will finally have 
	the power to crush Ma and Pa and rule the Germanium Valley!  
	It is my destiny!\" He waves the disk in air for a while,
	and then places it back	down on the desk.";
	setfuse( endgame, 3, nil );
    }
    else if ( Wayne.count = 4 )
    {
        "\n\tHe turns his back to you and faces the window.  \"Yes, all
        this will be mine!  Every industrial park, every expressway,
	every wafer that comes out of the Germanium Valley --
	Mine! Mine! Mine!\"";
    }
    else if ( Wayne.count = 5 )
    {
        "\n\t\"When I was the boy wonder at G V Tech, they all laughed at me!
       Now they're all building on MY WORK! Fools who couldn't even begin to 
       understand!\"   Wayne is getting quite deranged now.";       
       remdaemon( WayneTalk, nil );
       setdaemon( endgame, nil );
    }
    Wayne.count := Wayne.count + 1;
}          


// end of drifomga.t5

