/* High Tech Drifter */
/* Copyright (c) 1988, 1990 by Jim B. Cser and Mike Roberts. */
// main file

#include <adv.t>
#include "drifstrt.t"
#include "drifomga.t"
#include "drifsecy.t"
#include "drifgpl.t"
#include "drifrock.t"
checkReach: function;
itemcnt: function;
listcont: function;
listcontcont: function;
turncount: function;
addweight: function;
addbulk: function;
incscore: function;
darkTravel: function;
scoreRank: function;
terminate: function;
die: function;
init: function;
pardon: function;
preinit: function;
secLeave: function;
Patalk: function;
secReturn: function;
giveBox: function;
guard2fence: function;
meterOn: function;
roboCrash: function;
WayneTalk: function;
endgame: function;
replay: function;
secChew: function;
darkTravel: function
{
    "You stumble around in the dark, and don't get anywhere. ";
}
scoreRank: function
{
    local s;
    
    s := global.score;
    "\n\tIn a total of "; say( global.turnsofar ); 
    " turns, you have achieved ";
    say( s ); " points (out of "; say( global.maxscore );
    " possible points), giving you the rank of ";
    
    if ( s < 5 )
        "cleanroom laundry collector";
    else if ( s < 10 )
        "floppy disk duplication engineer";
    else if ( s < 20 )
        "junior lab assistant";
    else if ( s < 30 )
        "lab assistant";
    else if ( s < 40 )
        "associate engineer";
    else if ( s < 50 )
        "senior engineer";
    else if ( s < 60 )
        "principal investigator";
    else if ( s < 75 )
        "research director";
    else if ( s < 90 )
        "vice president in charge of research";
    else if ( s < 100 )
        "senior vice president";
    else
        "president and CEO";
    ". ";
}
terminate: function
{
    "\bThanks for playing High Tech Drifter.  Remember, if you've
    enjoyed playing this game just half as much as we've enjoyed
    bringing it to you, then we've enjoyed it twice as much as
    you!\b";
}
die: function
{
    local playOver;

    "\b*** You have died ***";
    replay();
}
init: function
{
    version.sdesc;
    "\nA TADS Text Adventure
    \bCopyright (c) 1988, 1990 by James B.\ Cser and Michael J.\ Roberts.
    All Rights Reserved.
    \b\b\tIt was a more exciting time, back then in the Information Age.
    Great advances were made in electronics and communications technology, but
    while some lands prospered and flourished, others were left to blow away 
    with the dust.  Some rugged individuals, like yourself, wandered
    from town to town, seeking their fortune or just trying to do a little good.
    You didn't have a name, so people just called you (start music):
    \b\b***** HIGH TECH DRIFTER *****\b\b";
    setdaemon( turncount, nil );
    Me.location := startroom;
    Me.travelTo( startroom );

    global.maxscore := 100;
    
    setversion( 'Deep Space Drifter 1.0' );
}
pardon: function
{
    "I beg your pardon?";
}
preinit: function
{
}

replay: function
{
    local playOver;

    scoreRank();
    "\bYou may restore a saved game, start over, quit, or undo
    the current command.\n";
    while ( 1 )
    {
        local resp;

	"\nPlease enter RESTORE, RESTART, QUIT, or UNDO: >";
        resp := upper(input());
        if ( resp = 'RESTORE' )
	{
	    resp := askfile( 'File to restore' );
	    if ( resp = nil ) "Restore failed. ";
	    else if ( restore( resp )) "Restore failed. ";
	    else
	    {
	        setscore( global.score, global.turnsofar );
		abort;
	    }
	}
        else if ( resp = 'RESTART' )
	{
	    setscore( 0, 0 );
            restart();
	}
	else if ( resp = 'QUIT' )
        {
	    terminate();
            quit();
	    abort;
        }
	else if (resp = 'UNDO')
	{
	    if (undo())
	    {
		"(Undoing one command)\b";
		Me.location.lookAround(true);
	        setscore(global.score, global.turnsofar);
		abort;
	    }
	    else
		"Sorry, no undo information is available. ";
	}
    }
}
numObj: object              // when a number is used in a player command,
    value = 0               //  this is set to its value
    sdesc = "that"
    adesc = "that"
    thedesc = "that"
    verDoTypeOn( actor, io ) = {}
    doTypeOn( actor, do ) = { "\"Tap, tap, tap, tap...\" "; }
    verIoTurnTo( actor ) = {}
    ioTurnTo( actor, do ) = { do.doTurnTo( actor, self ); }
;
strObj: object              // when a string is used in a player command,
    value = ''              //  this is set to its value
    sdesc = "that"
    adesc = "that"
    thedesc = "that"
    verDoTypeOn( actor, io ) = {}
    doTypeOn( actor, io ) = { "\"Tap, tap, tap, tap...\" "; }
    verDoSave( actor ) = {}
    doSave( actor ) =
    {
        if (save( self.value ))
            "Save failed. ";
        else
            "Saved. ";
	abort;
    }
    verDoRestore( actor ) = {}
    doRestore( actor ) =
    {
        if (restore( self.value ))
            "Restore failed. ";
        else
	{
            "Restored. ";
	    setscore( global.score, global.turnsofar );
	}
        abort;
    }
    doScript( actor ) =
    {
        logging( self.value );
        "Writing script to "; say( self.value ); ".\n";
        abort;
    }
    doSay( actor ) =
    {
        "Okay, \""; strObj.value; "\".";
    }
;
global: object
    turnsofar = 0                            // no turns have transpired so far
    score = 0                            // no points have been accumulated yet
    maxscore = 100                                    // maximum possible score
    verbose = nil                             // we are currently in TERSE mode
    awakeTime = 0               // time that has elapsed since the player slept
    sleepTime = 400     // interval between sleeping times (longest time awake)
    lastMealTime = 0              // time that has elapsed since the player ate
    eatTime = 200         // interval between meals (longest time without food)
    lamplist = []              // list of all known light providers in the game
;
Me: basicMe
;
version: object
    sdesc = "High Tech Drifter\n(Release number: 1.0)\n"
;
nirvana: room
     sdesc = "nirvana"
     ldesc = "The magic place where nothing ever happens."
;
class mydoorway: doorway
    sdesc = "door"
    noun = 'door'
;
goToSleep: function
{
    "***\bYou wake up some time later, feeling refreshed. ";
}
